//
// Created by sanhuazhang on 2019/05/02
//

/*
 * Tencent is pleased to support the open source community by making
 * WCDB available.
 *
 * Copyright (C) 2017 THL A29 Limited, a Tencent company.
 * All rights reserved.
 *
 * Licensed under the BSD 3-Clause License (the "License"); you may not use
 * this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 *       https://opensource.org/licenses/BSD-3-Clause
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "CustomConfig.hpp"
#include "Assertion.hpp"

namespace WCDB {

CustomConfig::CustomConfig(const Invocation &invocation, const Invocation &uninvocation)
: Config(), m_invocation(invocation), m_uninvocation(uninvocation)
{
}

CustomConfig::~CustomConfig() = default;

bool CustomConfig::invoke(InnerHandle *handle)
{
    WCTRemedialAssert(
    m_invocation != nullptr, "Invocation should not be null.", return false;);
    return m_invocation(handle);
}

bool CustomConfig::uninvoke(InnerHandle *handle)
{
    bool succeed = true;
    if (m_uninvocation != nullptr) {
        succeed = m_uninvocation(handle);
    }
    return succeed;
}

} //namespace WCDB
